package de.unima.ki.javakurs.tag2.dame;

import static junit.framework.Assert.*;

import org.junit.Test;

public class DameTest {
	
	@Test
	public void testNumOfBadPairs1()  {
		int[] field = new int[]{0,0,0,0,0,0,0,0};
		// should result in 7+6+5+4+3+2+1+0 bad pairs = 28
		int result = Dame.getNumOfBadPairs(field);
		assertEquals("all queens in same column should give 28 bad pairs", 28, result);
	}
	
	@Test
	public void testNumOfBadPairs2()  {
		int[] field = new int[]{0,1,2,3,4,5,6,7};
		// should result in 7+6+5+4+3+2+1+0 bad pairs = 28
		int result = Dame.getNumOfBadPairs(field);
		assertEquals("all queens in same diagonal should give 28 bad pairs", 28, result);
	}
	
	@Test
	public void testNumOfBadPairs3()  {
		int[] field = new int[]{0,2,4,6,1,3,5,7};
		// should result in 7+6+5+4+3+2+1+0 bad pairs = 28
		int result = Dame.getNumOfBadPairs(field);
		assertEquals("close to a perfect solution, just one bad pair", 1, result);
	}
	
	@Test
	public void transformToBetterNeighbor1()  {
		int[] field = new int[]{0,0,0,0,0,0,0,0};
		transformationTest(field);
	}
	
	@Test
	public void transformToBetterNeighbor2()  {
		int[] field = new int[]{0,1,2,3,4,5,6,7};
		transformationTest(field);
	}
	
	@Test
	public void transformToBetterNeighbor3()  {
		int[] field = new int[]{0,2,4,6,1,3,5,7};
		transformationTest(field);
	}
	
	private void transformationTest(int[] field) {
		int resultBefore = Dame.getNumOfBadPairs(field);
		boolean transformed = Dame.transformToBetterNeigbor(field);
		int resultAfter = Dame.getNumOfBadPairs(field);
		if (transformed) {
			assertTrue("a transformed field should have a better score (before=" + resultBefore + ", after=" + resultAfter + ")", resultBefore  > resultAfter);
		}
		else {
			assertFalse("no transformation applied, before and after score should be equal  (before=" + resultBefore + ", after=" + resultAfter + ")", resultBefore == resultAfter);
		}
	}	
	
}
