package de.unima.ki.javakurs.tag2.pruefbits;

import org.junit.Test;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

public class PruefbitsTest {
	
	// valid example
	public static boolean[][] example1 = new boolean[][]{
		{true,  false, true},
		{true,  true,  false},
		{false, true,  false},
	};

	// invalid datablock (checkbit for first row wrong,
	// checkbit for first column wrong)
	public static boolean[][] example2 = new boolean[][]{
		{false, false, true},
		{true,  true,  false},
		{false, true,  false},
	};	
	
	// valid datablock
	public static boolean[][] example3 = new boolean[][]{
		{true,  false, false, true},
		{true,  true,  false, false},
		{false, false, false, false},
		{false, true,  false, false},
	};	
	
	// invalid datablock (master checkbit wrong)
	public static boolean[][] example4 = new boolean[][]{
		{true,  false, false, true},
		{true,  true,  false, false},
		{false, false, false, false},
		{false, true,  false,  true},
	};
	
	// valid datablock
	public static boolean[][] example5 = new boolean[][]{
		{true,  true,  true,  true,  false},
		{true,  true,  true,  true,  false},
		{true,  true,  true,  true,  false},
		{true,  true,  true,  true,  false},
		{false, false, false, false, false},

	};
	
	// invalid datablock (second col checkbit is wrong)
	public static boolean[][] example6 = new boolean[][]{
		{true,  true,  true,  true,  false},
		{true,  true,  true,  true,  false},
		{true,  true,  true,  true,  false},
		{true,  true,  true,  true,  false},
		{false, true, false, false,  true},
	};		
	

	@Test
	public void testIsValidDataBlock1() {
		assertTrue(Pruefbits.isValidDataBlock(example1));
	}
	
	@Test
	public void testIsValidDataBlock2() {
		assertFalse(Pruefbits.isValidDataBlock(example2));
	}
	
	@Test
	public void testIsValidDataBlock3() {
		assertTrue(Pruefbits.isValidDataBlock(example3));
	}
	
	@Test
	public void testIsValidDataBlock4() {
		assertFalse(Pruefbits.isValidDataBlock(example4));
	}
	
	@Test
	public void testIsValidDataBlock5() {
		assertTrue(Pruefbits.isValidDataBlock(example5));
	}
	
	@Test
	public void testIsValidDataBlock6() {
		assertFalse(Pruefbits.isValidDataBlock(example6));
	}
	
}
