package de.unima.ki.javakurs.tag2.wetterstation;

import static junit.framework.Assert.assertEquals;
import static org.junit.Assert.*;

import org.junit.Test;

import de.unima.ki.javakurs.tag2.geo2.Geo2;
import de.unima.ki.javakurs.tag2.palindrom.Palindrom;

public class WetterTest {

	@Test
	public void durchschnittTest1() {
		int [] myTag = {1 ,2 ,3 ,4 ,5 ,6 ,7 ,8,9,10,11,12,13,14};
		double [] myTemperatur = {12, 14,  9, 12, 15, 16, 15, 15, 11,  8, 13, 13, 15, 12};
		double result = Wetter.durchschnitt(myTag, myTemperatur);
		assertEquals("",12.857142857142858, result);
	}
	
	@Test
	public void temperaturumschwungTest1() {
		int [] myTag = {1 ,2 ,3 ,4 ,5 ,6 ,7 ,8,9,10,11,12,13,14};
		double [] myTemperatur = {12, 14,  9, 12, 15, 16, 15, 15, 11,  8, 13, 13, 15, 12};
		String result = (Wetter.print(Wetter.temperaturumschwung(myTag, myTemperatur)));
		
		assertEquals("","3 4 ", result);
	}
	
	@Test
	public void durchschnittTest2() {
		int [] myTag = {1 ,2 ,3 ,4 ,5 ,6 ,7 ,8,9,10,11,12,13,14,15,16,17,18,19,20};
		double [] myTemperatur = {12.5, 12.2,  19, 2.9, 15.2, 6.7, 15.4, 1.8, -1.8,  8.2, 13.2, 30.0, 17.2, 20.5 ,0.2, 8.5, 4.5, 5.7, 8.7, 27.9};
		double result = Wetter.durchschnitt(myTag, myTemperatur);
		assertEquals("",11.424999999999999, result);
	}
	
	@Test
	public void temperaturumschwungTest2() {
		int [] myTag = {1 ,2 ,3 ,4 ,5 ,6 ,7 ,8,9,10,11,12,13,14,15,16,17,18,19,20};
		double [] myTemperatur = {12.5, 12.2,  19, 2.9, 15.2, 6.7, 15.4, 1.8, -1.8,  8.2, 13.2, 30.0, 17.2, 20.5 ,0.2, 8.5, 4.5, 5.7, 8.7, 27.9};
		String result = (Wetter.print(Wetter.temperaturumschwung(myTag, myTemperatur)));
		
		assertEquals("","15 16 ", result);
	}
	

}
